# Visual Studio Load and Web Test plugins by LIL

The Project builds a DLL file (LIL_VSTT_Plugins.dll) which you need to add a reference to in your Test Project in order to use the plugins. Either copy the project into your Test Project's Solution, and reference the project in your Test Project, or place a copy of the built dll file in each Test Project (create a lib directory and copy the dll to it, add the DLL file as an existing item, and add a reference in your test project by browsing to the dll file). The DLL will be deployed automatically to all agents in your test rig.

## License

The project source code and binaries are open source and under the MS-RL license unless otherwise specified in the code or in the folders of such code.
By using the code (reading, compiling, linking, distributing or in any other way make use of the code) you accept the license terms applicable for the code in question.
You can download or read the MS-RL license here: https://opensource.org/licenses/MS-RL

In short, 
- you are not allowed to distribute the software or any portion of the software without distributing the complete code and license together with the software. 
- you are not allowed to remove any trademarks, copyrights or attributions from the code.

## Building

Pre build versions of the DLL and the PDB Debug symbols files are available in the project wiki home page for download. Please remember to remove the blocking of the file that windows does for downloaded executable files, otherwise it will not load. Most windows setups also block executable files on shared filesystems, so you might want to place the file local.

Build the Project using Release config and make sure you build for .NET Framework 4.5 if you want to use the TLS 1.2 features (see the Wiki Pages for more details). The solution also contains a Test Project, it is not needed for use of the plugins, it is only used to test the plugins during development. You can use this Test Project as a starting point for your Test Project or use it to play arround with the plugin as well, since it already contains a reference to the plugin DLL project.

## Versioning

Itentionally, the file and build versions are currently being kept at 1.3.0.0. This in order to not break compatibility with web and load test files that make use of the plugin. Unfortunatly, if the file or build version of the DLL is changed, the DLL is no longer loaded  for that web test. Rebuilding does not help, since the version previously used is hard coded in text in the XML file for the web or load test. The plugin needs to be removed, and then added again, in order to work. When doing this, all property settings for the plugin are lost. A workarround if this happens, is to copy paste / drag and drop the plugin with its settings from the old web or load test into a new one, using the new version. This would require a potentialoly high amount of manual work each time a version is changed (even minor version changes that would not actually break compatibilty). For this reason, the file and build versions are no longer updated.
This means that other mechanisms of versioning need to be used, like changing the name of the file and add a date or the build number. This is not done automatically but is recommended. You can also use diffrent paths and directories containg dates or build numbers to keep track of diffrent versions if you need. The best solution is to add the plugin DLL file to your solution and version control it together with the code that uses it. You can also add the entire DLL project to your project solution, add reference the project instead of a file. This way, your project always has the right "version" of the plugin, and you check out the code of the version that you need from the central GIT repository, and then check it into your own version control system with your test project.

## Project Gitlab
https://git.lightsinline.se/products/VSTT-Plugins

This project is maintained on a GitLab server, where you can find the latest code, builds, issues and documention. Register an account (for free) if you want to get support or create issues/bugs/suggestions. With an account, you can also create a personal fork (clone) of the project and get the plugin code in your own repository and maintain your own modified version. You may also invite others to join your project or share the code. If you create code you want to get added to the original code base, you are welcome to create a merge request to get it added to the master branch for others to use.

## Bouncy Castle API

Contains the code of the Bouncy Castle C# API Release 1.8.1
Please note that the Bouncy Castle API source files are under a diffrent license (http://www.bouncycastle.org/csharp/licence.html)
and BZIP2 source files are under the Apache License Version 2.0 (http://www.apache.org/licenses/LICENSE-2.0)

For more information, wiki, docs, latest code, donations etc please visit http://www.bouncycastle.org
